using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Modelos_Listado_Filtros;
using Exferia_CRM._0_Modelos;
using Exferia_CRM.General;
using Exferia_EntityFramework;
using Exferia_General;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Exferia_CRM._3_Vistas.Listados
{
    public class ABS_Listado_CRMS_Liquidaciones_Filtros_Internos : ABS_Listado
    {
        private Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo = new Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo>();
        private INTERNO_ValoresGenerales_Modelo g_mdl_INTERNO_ValoresGenerales_Modelo = null;

        //Constructor
        public ABS_Listado_CRMS_Liquidaciones_Filtros_Internos(INTERNO_ValoresGenerales_Modelo _mdl_INTERNO_ValoresGenerales_Modelo)
        {
            g_mdl_INTERNO_ValoresGenerales_Modelo = _mdl_INTERNO_ValoresGenerales_Modelo;

            Rellenar_Columnas();
        }

        private void Rellenar_Columnas()
        {
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CRMS_Liquidaciones_Listado_Modelo.id), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(true, nameof(INTERNO_CRMS_Liquidaciones_Listado_Modelo.id), "id", Enumerados.G_ENUM_TIPOSDATOS.LONG, true, 0, false, false, true, false, "", null));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CRMS_Liquidaciones_Listado_Modelo.TipoAccion), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CRMS_Liquidaciones_Listado_Modelo.TipoAccion), "Tipo de Acción", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 120, true, true, true, false, "", null));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CRMS_Liquidaciones_Listado_Modelo.fechaHora_Inicio), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CRMS_Liquidaciones_Listado_Modelo.fechaHora_Inicio), "Fecha y Hora Inicio", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 130, true, true, true, false, "", null));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CRMS_Liquidaciones_Listado_Modelo.fechaHora_Fin), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CRMS_Liquidaciones_Listado_Modelo.fechaHora_Fin), "Fecha y Hora Fin", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 130, true, true, true, false, "", null));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CRMS_Liquidaciones_Listado_Modelo.kilometrosIniciales), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CRMS_Liquidaciones_Listado_Modelo.kilometrosIniciales), "Kilometros Iniciales", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 105, true, false, false, false, "", null));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CRMS_Liquidaciones_Listado_Modelo.kilometrosFinales), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CRMS_Liquidaciones_Listado_Modelo.kilometrosFinales), "Kilometros Finales", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 100, true, false, false, false, "", null));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CRMS_Liquidaciones_Listado_Modelo.combustible), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CRMS_Liquidaciones_Listado_Modelo.combustible), "Combustible", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 80, true, false, false, false, "", null));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CRMS_Liquidaciones_Listado_Modelo.observaciones), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CRMS_Liquidaciones_Listado_Modelo.observaciones), "Observaciones", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 200, true, false, false, false, "", null));

            //Empleado
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_EMPLEADO = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_CRMS_Liquidaciones_Listado_Modelo.idEmpleado), nameof(MAE_Empleados), nameof(MAE_Empleados.id), nameof(MAE_Empleados.codigo), nameof(MAE_Empleados.nombre), nameof(MAE_Empleados.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CRMS_Liquidaciones_Listado_Modelo.Empleado), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CRMS_Liquidaciones_Listado_Modelo.Empleado), "Empleado", Enumerados.G_ENUM_TIPOSDATOS.RELACIONADA, false, 250, true, false, true, true, "", null, false, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_EMPLEADO));

            //Terminal
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_TERMINAL = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_CRMS_Liquidaciones_Listado_Modelo.idTerminal), nameof(CRM_Terminales), nameof(CRM_Terminales.id), nameof(CRM_Terminales.codigo), nameof(CRM_Terminales.descripcion), nameof(CRM_Terminales.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CRMS_Liquidaciones_Listado_Modelo.Terminal), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CRMS_Liquidaciones_Listado_Modelo.Terminal), "Terminal", Enumerados.G_ENUM_TIPOSDATOS.RELACIONADA, false, 250, true, false, false, true, "", null, false, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_TERMINAL));

            //Vehiculo
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_VEHICULO = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_CRMS_Liquidaciones_Listado_Modelo.idVehiculo), nameof(MAE_Vehiculos), nameof(MAE_Vehiculos.id), nameof(MAE_Vehiculos.matricula), nameof(MAE_Vehiculos.descripcion), nameof(MAE_Vehiculos.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CRMS_Liquidaciones_Listado_Modelo.Vehiculo), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CRMS_Liquidaciones_Listado_Modelo.Vehiculo), "Vehículo", Enumerados.G_ENUM_TIPOSDATOS.RELACIONADA, false, 250, true, false, false, true, "", null, false, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_VEHICULO));
        }

        public override List<dynamic> LISTADO()
        {
            return Registros;
        }

        public override INTERNO_OpcionesDetalle_Modelo DATOS_OPCION()
        {
            return Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_CRMS_LIQUIDACIONES);
        }

        public override string NOMBRELISTADO_ALMACENARCONFIGURACION()
        {
            return Variables.G_STR_OPCION_CRMS_LIQUIDACIONES;
        }

        public override Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> LISTADO_COLUMNAS()
        {
            return g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo;
        }

        public override string ORDENACION_NOMBRECOLUMNA_PORDEFECTO()
        {
            return nameof(INTERNO_CRMS_Liquidaciones_Listado_Modelo.fechaHora_Inicio);
        }

        public override string ORDENACION_TIPO_PORDEFECTO()
        {
            return "0";
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_1()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_2()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_3()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_4()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_5()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_6()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_7()
        {
            return null;
        }

        public override List<INTERNO_ArbolSecundarioSeleccion_Modelo> LISTADO_ARBOLSECUNDARIOSELECCION()
        {
            return null;
        }

        public override List<INTERNO_Listado_Paginado_Filtro_Modelo> FILTRADO_PARAPAGINADO()
        {
            return null;
        }

        public override List<string> LISTADOCAMPOS_ENVIAR_A_MANTENIMIENTO()
        {
            return null;
        }
    }
}
